<form #form="ngForm">
  <table>
    <tr>
      <th>Name</th>
      <td>
        <input type="text" [name]="'name'" [(ngModel)]="v.name" #name="ngModel" 
                required minlength="3" pattern="[a-zA-Z ]+" />
      </td>
      <td>
        <ul *ngIf="name.dirty && name.invalid">
          <li *ngIf="name.errors.required">Must have a value</li>
          <li *ngIf="name.errors.pattern">Only letters and blank</li>
          <li *ngIf="name.errors.minlength">
            At least {{name.errors.minlength.requiredLength}} chars
          </li>
        </ul>
      </td>
    </tr>
    <tr>
      <th>Age</th>
      <td>
        <input type="number" [name]="'age'" [(ngModel)]="v.age" #age="ngModel" required min="18" max="70" />
      </td>
      <td>
        <ul *ngIf="age.dirty && age.invalid">
          <li *ngIf="age.errors.required">Must have a value</li>
          <li *ngIf="age.errors.min">At least age {{age.errors.min.min}}</li>
          <li *ngIf="age.errors.max">At most age {{age.errors.max.max}}</li>
        </ul>
      </td>
    </tr>
    <tr>
      <th></th>
      <td colspan="2" class="buttons">
        <button type="submit" (click)="onSubmit()" [disabled]="form.invalid" class="submit">Submit</button>
        <button type="reset" (click)="onCancel()" class="cancel">Cancel</button>
      </td>
    </tr>
  </table>
</form>

<hr />
<div class="debug">
  <pre>
payload: {{v | json}}
name.errors: {{name.errors | json}}
age.errors : {{age.errors | json}}
    </pre>
</div>
